///////////////////////////////////////////////////////////////////////////////////
// File     : sys_handler.h
// Date     : 01/04/2012
// Author   : alain greiner and joel porquet
// Copyright (c) UPMC-LIP6
///////////////////////////////////////////////////////////////////////////////////

#ifndef _SYS_HANDLER_H
#define _SYS_HANDLER_H

//////////////////////////////////////////////////////////////////////////////////
//     Syscall Vector Table (indexed by syscall index)
//////////////////////////////////////////////////////////////////////////////////

extern const void * _syscall_vector[64];

//////////////////////////////////////////////////////////////////////////////////
// Prototypes os the syscall handlers (other than peripheral drivers)
//////////////////////////////////////////////////////////////////////////////////

void         _sys_ukn();

void         _proc_xyp( unsigned int* x,
                        unsigned int* y,
                        unsigned int* p );

void         _task_exit();

void         _context_switch();

unsigned int _local_task_id();

unsigned int _global_task_id();

unsigned int _thread_id();

unsigned int _procs_number( unsigned int  cluster_id, 
                            unsigned int* number );

unsigned int _vobj_get_vbase( char*         vspace_name, 
                              char*         vobj_name, 
                              unsigned int* vobj_vbase );

unsigned int _vobj_get_length( char*         vspace_name, 
                               char*         vobj_name, 
                               unsigned int* vobj_length );

unsigned int _get_xy_from_ptr( void*          ptr,
                               unsigned int*  x,
                               unsigned int*  y );


#endif

// Local Variables:
// tab-width: 4
// c-basic-offset: 4
// c-file-offsets:((innamespace . 0)(inline-open . 0))
// indent-tabs-mode: nil
// End:
// vim: filetype=c:expandtab:shiftwidth=4:tabstop=4:softtabstop=4

